{-
  PP, laboratorul 8: tipuri de date utilizator
-}

import Data.List
import TestPP

{-
  1. (2p) Numere complexe
  Se dă tipul de date Complex, reprezentând numerele complexe, i.e.
  primul câmp îl reprezintă partea reală, iar cel de-al doilea partea
  imaginară.

  Implementați următoarele operații cu numere complexe:
  - compararea la egalitate (eqC) între două numere
  - adunarea (addC) și scăderea (subC) a două numere
  - conjugata (conjC) unui număr
  - modulul (absC) unui număr

  Pentru mai multe detalii, consultați:
  https://en.wikipedia.org/wiki/Complex_number#Elementary_operations
-}

test1 :: TestPP ()
test1 = tests 1 2
        [ testCond (eqC c1 c1) "eqC" 0.5
	, testCond (((c1 `addC` c2) `subC` (C 1 1)) `eqC` (C 6 6)) "addC, subC" 0.5
	, testCond ((conjC c2) `eqC` (C 4 (-5))) "conjC" 0.5
	, testCond ((absC c2) `eqR` 6.4031) "absC" 0.5
	]
    where
          c1 = C 3 2
          c2 = C 4 5
	  eqR a b = abs (a - b) < 0.0001


data Complex = C
  { realC :: Double
  , imgC  :: Double
  } deriving Show

-- Hint: dat fiind că numerele complexe sunt definite pe baza a două
-- numere în virgulă mobilă, puteți implementa egalitatea aproximativă
-- dintre două numere, folosind absC și subC.
eqC :: Complex -> Complex -> Bool
eqC c1 c2 = undefined
  where eps = 0.0001

addC :: Complex -> Complex -> Complex
addC = undefined

subC :: Complex -> Complex -> Complex
subC = undefined

conjC :: Complex -> Complex
conjC = undefined

absC :: Complex -> Double
absC = undefined

{-
 2. (4p) Liste imbricate
  Se dă tipul de date SList a care are funcționalități
  asemănătoare listelor din limbajele Lisp (e.g. Scheme, Racket, Clojure),
  permițând componente la diferite niveluri de imbricare.
  Ex: Lista din Racket '(1 (3 4) (2)) să poată fi definită în Haskell
  folosind SList.
  Definiți:
  - emptySList, lista vidă
  - consElem, adaugă un element în capul unei liste
    Ex: consElem 1 '((3 4) (2)) == '(1 (3 4) (2))
  - consList, adaugă o listă (imbricată) în capul unei liste
    Ex: consList '(2 3) '(1 2) == '((2 3) 1 2)
  - headSList, ia primul element dintr-un SList
  - tailSList, ia restul SList-ului
  - deepEqual, o funcție ce verifică egalitatea a două SList - este
    interzisă rezolvarea prin derivarea clasei Eq
  - flatten, întoarce lista cu elementele din SList (pe același nivel)
-}

test2 :: TestPP ()
test2 = tests 2 4
        [ testCond (deepEqual l1 l1 && not (deepEqual l1 l2)) "simple lists" 0.5
	, testCond (deepEqual (consElem 2 $ l3) l2) "less simple lists" 0.75
	, testCond (not (deepEqual (consList l1 emptySList) l4)) "different lengths" 0.5
	, testCond (deepEqual (consList l1 (Atom 1)) l4) "consList" 0.5
	, testCond (deepEqual (headSList $ tailSList l2)
	                      (consElem 1 $ consElem 1 emptySList)) "head, tail" 0.5
	, testCond (deepEqual (tailSList $ consList l1 (Atom 1)) l1) "consList tail" 0.5
	, testVal (flatten l2) [2, 1, 1, 3] "flatten" 0.75
	]
    where
          l1 = consElem 1 $ emptySList
          l2 = consElem 2 $ consList (consElem 1 $ consElem 1 emptySList) $
               consElem 3 emptySList
          l3 = consList (consElem 1 $ consElem 1 emptySList) $ consElem 3 $
               emptySList
	  l4 = consList l1 $ consElem 1 $ emptySList


data SList a = Atom a | List [SList a] deriving Show

emptySList :: SList a
emptySList = undefined

consElem :: a -> SList a -> SList a
consElem = undefined

consList :: SList a -> SList a -> SList a
consList = undefined

headSList :: SList a -> SList a
headSList = undefined

tailSList :: SList a -> SList a
tailSList = undefined

deepEqual :: Eq a => SList a -> SList a -> Bool
deepEqual = undefined

flatten :: SList a -> [a]
flatten = undefined

{-
  3. (4p) Arbori binari de căutare
  Definiți funcții pentru a crea un arbore binar de căutare pornind de la o
  listă de elemente, căutarea unui element într-un arbore binar de căutare
  dat și o funcție care întoarce lista elementelor din parcurgerea în
  inordine a arborelui.

  Hint: Este de preferat ca arborele binar de căutare să fie echilibrat,
  lucru ușor de obținut la creare dacă lista de elemente este sortată.
-}

test3 :: TestPP ()
test3 = tests 3 4
        [ testVal (findElem 1 bst) (Just 1) "findElem" 2
	, testVal (inorder bst) [1, 2, 3, 4] "inorder" 2
	]
    where
         bst = makeBST [2, 3, 1, 4]


data BST a = BSTNod a (BST a) (BST a) | BSTNil deriving Show

makeBST :: Ord a => [a] -> BST a
makeBST = undefined

findElem :: (Ord a, Eq a) => a -> BST a -> Maybe a
findElem = undefined

inorder :: BST a -> [a]
inorder = undefined


{-
  4. (BONUS, 1.5p) Arbori binari de căutare
  Lucrând pe același tip de date de la exercițiul anterior, definiți
  funcția care află strămoșul comun a două noduri.
  Vom lucra doar pe arbori ce nu conțin valori duplicate!
-}
test4 :: TestPP ()
test4 = tests 4 1.5
        [ testVal (lowestCommonAncestor t 1 3) (Just 2) "lowestCommonAncestor 1, 3" 0.5
        , testVal (lowestCommonAncestor t 4 5) (Just 4) "lowestCommonAncestor 4, 5" 0.5
	, testVal (lowestCommonAncestor t 4 7) Nothing "lowestCommonAncestor 4, 7" 0.5
	]
    where
          t = makeBST [1, 2, 3, 4, 5, 6]

lowestCommonAncestor :: (Ord a, Eq a) => BST a -> a -> a -> Maybe a
lowestCommonAncestor t n1 n2 = undefined


{-
  5. (BONUS, 1.5p) Arbori binari de căutare
  Definiți funcția nodesDistance, care returnează distanța
  între două noduri (numărul minim de arce ce trebuie parcurse
  pentru a ajunge dintr-un nod în celălalt).
  Vom lucra doar pe arbori ce nu conțin valori duplicate!
-}
test5 :: TestPP ()
test5 = tests 5 1.5
        [ testVal (nodesDistance t 1 5) (Just 4) "nodesDistance 1, 5" 0.5
        , testVal (nodesDistance t 4 5) (Just 2) "nodesDistance 4, 5" 0.5
	, testVal (nodesDistance t 2 7) Nothing "nodesDistance 2, 7" 0.5
	]
    where
          t = makeBST [1, 2, 3, 4, 5, 6]

nodesDistance :: (Ord a, Eq a) => BST a -> a -> a-> Maybe Int
nodesDistance t n1 n2 = undefined


{-
  6. (BONUS, 2p) Arbori binari de căutare
  Definiți funcția subtree, care verifică dacă 
  arborele t1 este un subarbore al arborelui t2.
  Este interzisă rezolvarea prin derivarea clasei Eq!
  Ex: subtree (makeBST [1,2]) (makeBST [1,2,3,4]) == True
  Vom lucra doar pe arbori ce nu conțin valori duplicate!
-}

test6 :: TestPP ()
test6 = tests 6 2
        [ testCond (subtree (BSTNod 2 (BSTNod 1 BSTNil BSTNil) BSTNil) t) "subtree [1, 2]" 0.75
	, testCond (subtree t t) "subtree [1, 2, 3, 4]" 0.5
	, testCond (not $ subtree (BSTNod 4 (BSTNod 3 BSTNil BSTNil) BSTNil) t) "not $ subtree [3, 4]" 0.75
	]
    where
          t = BSTNod 3 (BSTNod 2 (BSTNod 1 BSTNil BSTNil) BSTNil) (BSTNod 4 BSTNil BSTNil)


subtree :: (Eq a, Ord a) => BST a -> BST a -> Bool
subtree = undefined


{-
Helpers for testing :)
-}
allTests = [test1, test2, test3, test4, test5, test6]
check = runTestPP $ sequence_ allTests
[check1, check2, check3, check4, check5, check6] = map runTestPP allTests
